/* IndexedCollection definitions for the use of subclass implementations only

   Copyright (C) 1993 R. Andrew McCallum <mccallum@cs.rochester.edu>
   Dept. of Computer Science, U. of Rochester, Rochester, NY  14627

   This file is part of the GNU Objective-C Collection library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

#ifndef __IndexedCollectionPrivate_h_INCLUDE_GNU
#define __IndexedCollectionPrivate_h_INCLUDE_GNU

#include <coll/CollectionPrivate.h>
#include <coll/IndexedCollecting.h> /* for COLL_NO_INDEX */

/* To be used inside a method for making sure the index
   is not COLL_NO_INDEX */


/*
#define CHECK_INDEX_RANGE(INDEX, OVER, DEFAULT_RET_VAL)
if (INDEX >= OVER)
  {
    TRY_DOING_FORWARD_WITH(@selector(errorIndexRangeInSel:withArgList:defaultReturn:),
			   DEFAULT_RET_VAL);
    return DEFAULT_RET_VAL;
  }
*/


/* To be used inside a method for determining if the index
   is below invalid maximum */

#define INDEX_RANGE_WARNING(INDEX, OVER)\
(((INDEX) >= (OVER))\
 ?\
 ([self errorIndex:(INDEX) beyondRange:(OVER) inMethod:_cmd],YES)\
 :\
 (NO))


@interface IndexedCollection (ErrorReporting)
- errorIndex: (unsigned)index beyondRange: (unsigned)over inMethod: (SEL)aSel;
@end

#endif /* __IndexedCollectionPrivate_h_INCLUDE_GNU */
